<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
</head>

<body></body>
<script>
    ///////////////       Example 1               ///////////////
    //Tạo 1 class
    class Car {
        constructor(paramName, paramYear) {
            this.name = paramName;
            this.year = paramYear;
        }
        age(x) {
            return x - this.year;
        }
    }

    let date = new Date();
    let year = date.getFullYear();

    var vCar = new Car("BMW", 2014);
    console.log("Car name: " + vCar.name);
    console.log("Năm sản xuất: " + vCar.year);
    console.log("My car is " + vCar.age(year) + " years old");

    ///////////////       Example 2               ///////////////
    //Tạo 1 class
    class Rectangle {
        //Hàm tạo(constructor)
        constructor(length, width) {
            this.length = length;
            this.width = width;
        }

        //Phương thức của class
        getArea() {
            return this.length * this.width;
        }
    }

    //Tạo class Square kế thừa class Rectangle
    class Square extends Rectangle {
        // constructor của class con
        constructor(length) {
            //Gọi đến constructor của class cha
            super(length, length);
        }

        //Phương thức của class con
        getPerimeter() {
            return 2 * (this.length + this.width);
        }
    }
    // Khởi tạo đối tượng (thể hiện của class Rectangle)
    let rectangle = new Rectangle(5, 10);
    //Tính diện tích hình chữ nhật
    console.log(rectangle.getArea()); // 50
</script>

</html>